config/routes.rb
# frozen_string_literal: true

require 'avalon/routing/can_constraint'

Rails.application.routes.draw do
  mount Samvera::Persona::Engine => '/'
  mount Blacklight::Engine => '/catalog'
  concern :searchable, Blacklight::Routes::Searchable.new
  concern :exportable, Blacklight::Routes::Exportable.new

  resource :catalog, only: [:index], as: 'catalog', path: '/catalog', controller: 'catalog' do
    concerns :searchable
  end

  # For some reason this needs to be after `resource :catalog` otherwise Blacklight will generate links to / instead of /catalog
  root to: "catalog#index"

  get '/mejs/:version', to: 'application#mejs'

  resources :solr_documents, only: [:show], path: '/catalog', controller: 'catalog' do
    concerns :exportable
  end

  resources :encode_records, only: [:show, :index] do
    collection do
      post :paged_index
      post :progress
    end
  end

  resources :checkouts, only: [:index, :create, :show, :update, :destroy], :constraints => lambda { |request| Avalon::Configuration.controlled_digital_lending_enabled? } do
    collection do
      patch :return_all
    end

    member do
      patch :return
    end
  end

  resources :bookmarks do
    concerns :exportable

    collection do
      delete 'clear'
      get 'delete'#, as: :delete_bookmarks
      post 'delete'
      get 'move'#, as: :move_bookmarks
      post 'move'
      get 'update_access_control'#, as: :update_access_control_bookmarks
      post 'update_access_control'
      post 'publish'#, as: :publish_bookmarks
      post 'unpublish'#, as: :unpublish_bookmarks
      get 'add_to_playlist'
      post 'add_to_playlist'
      get 'intercom_push'
      post 'intercom_push'
      get 'merge'
      post 'merge'
      get 'count', constraints: { format: 'json' }
    end
  end

  devise_for :users, controllers: { omniauth_callbacks: 'users/omniauth_callbacks', sessions: 'users/sessions' }
  devise_scope :user do
    Avalon::Authentication::Providers.collect { |provider| provider[:provider] }.uniq.each do |provider_name|
      match "/users/auth/#{provider_name}/callback", to: "users/omniauth_callbacks##{provider_name}", as: "user_omniauth_callback_#{provider_name}".to_sym, via: [:get, :post]
    end
  end

  mount BrowseEverything::Engine => '/browse'

  # Avalon routes
  match "/authorize", to: 'derivatives#authorize', via: [:get, :post]
  match "/authorize/:path", to: 'derivatives#authorize', via: [:get, :post]

  namespace :admin do
    resources :groups, except: [:show] do
      collection do
        put 'update_multiple'
      end
      member do
        put 'update_users'
      end
    end
    resources :collections do
      member do
        get 'edit'
        get 'remove'
        get 'items'
        get 'poster'
        post 'poster', action: :attach_poster, as: 'attach_poster'
        delete 'poster', action: :remove_poster, as: 'remove_poster'
      end
    end

    namespace :migration_report, controller: '/migration_status' do
      get '/', action: :index
      get ':class', action: :show, as: 'by_class'
      get ':id/detail', action: :detail, as: 'detail'
      get ':id/report', action: :report, as: 'report'
    end
  end

  resources :vocabulary, except: [:create, :destroy, :new, :edit]

  resources :collections, only: [:index, :show] do
    member do
      get :poster
    end
  end

  resources :media_objects, except: [:create, :update] do
    member do
      put :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update, action: :json_update, constraints: { format: 'json' }
      patch :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update_status
      get :progress, :action => :show_progress
      get 'content/:file', :action => :deliver_content, :as => :inspect
      get 'track/:part', :action => :show, :as => :indexed_section
      get 'section/:content', :action => :show, :as => :id_section
      get 'section/:content/stream', :action => :show_stream_details, :as => :section_stream
      get 'section/:content/embed', :to => redirect('/master_files/%{content}/embed')
      get 'tree', :action => :tree, :as => :tree
      get :confirm_remove
      post :add_to_playlist
      patch :intercom_push
      get :manifest
      get :move_preview, defaults: { format: 'json' }, constraints: { format: 'json' }
    end
    collection do
      post :create, action: :create, constraints: { format: 'json' }
      post :set_session_quality
      get :confirm_remove
      put :update_status
      # 'delete' has special signifigance so use 'remove' for now
      delete :remove, :action => :destroy
      get :intercom_collections
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit] do
      get :index, constraints: { format: 'json' }, on: :collection
    end
  end

  resources :master_files, except: [:new, :index] do
    member do
      get  'thumbnail', :to => 'master_files#get_frame', :defaults => { :type => 'thumbnail' }
      get  'poster',    :to => 'master_files#get_frame', :defaults => { :type => 'poster' }

      post 'thumbnail', :to => 'master_files#set_frame', :defaults => { :type => 'thumbnail', :format => 'html' }
      post 'poster',    :to => 'master_files#set_frame', :defaults => { :type => 'poster', :format => 'html' }
      post 'still',     :to => 'master_files#set_frame', :defaults => { :format => 'html' }
      get :embed
      post 'attach_structure'
      get :captions
      get :waveform
      match ':quality.m3u8', to: 'master_files#hls_manifest', via: [:get], as: :hls_manifest
      get 'structure', to: 'master_files#structure', constraints: { format: 'json' }
      post 'structure', to: 'master_files#set_structure', constraints: { format: 'json' }
      delete 'structure', to: 'master_files#delete_structure', constraints: { format: 'json' }
      post 'move'
      get 'transcript/:t_id', to: 'master_files#transcript'
      get :search
      
      if Settings.derivative.allow_download
        get :download_derivative
      end
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit] do
      member do
        get 'captions'
        get 'transcripts', :to => redirect('/master_files/%{master_file_id}/supplemental_files/%{id}')
      end
      get :index, constraints: { format: 'json' }, on: :collection
    end
  end

  match "iiif_auth_token/:id", to: 'master_files#iiif_auth_token', via: [:get], as: :iiif_auth_token

  resources :derivatives, only: [:create]
  match "/autocomplete", to: 'objects#autocomplete', via: [:get]
  match "/objects/:id", to: 'objects#show', via: [:get], :as => :objects
  match "/object/:id", to: 'objects#show', via: [:get]

  resources :playlists do
    resources :playlist_items, path: 'items', only: [:create, :update, :show] do
      get 'related_items'
    end
    member do
      patch 'update_multiple'
      delete 'update_multiple'
      patch 'regenerate_access_token'
      get 'refresh_info'
      get 'manifest'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_playlist'
      end
    end
  end

  resources :avalon_marker, only: [:create, :show, :update, :destroy]

  resources :comments, only: [:index, :create]

  resources :playlist_items, only: [:update], :constraints => {:format => /(js|json)/}

  resources :timelines do
    member do
      patch 'regenerate_access_token'
      post 'manifest', to: 'timelines#manifest_update', constraints: { format: 'json' }
      get 'manifest'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_timeline'
      end
    end
  end
  get '/timeliner', to: 'timelines#timeliner', as: :timeliner

  resources :dropbox, :only => [] do
    collection do
      delete :bulk_delete
    end
  end

  match "/oembed", to: 'master_files#oembed', via: [:get]

  constraints(Avalon::Routing::CanConstraint.new(:read, :about_page)) do
    mount AboutPage::Engine => '/about(.:format)', as: 'about_page'
  end
  get '/about(.:format)', to: redirect('/')
  get '/about/health.yaml', to: 'about_page/about#health', defaults: { :format => 'yaml' }
  get '/about/health(.:format)', to: redirect('/')

  constraints(Avalon::Routing::CanConstraint.new(:manage, :jobs)) do
    mount Sidekiq::Web, at: '/jobs', as: 'jobs'
  end
  get '/jobs(.:format)', to: redirect('/')

  scope :persona, as: 'persona' do
    resources :users, only: [:paged_index], controller: 'samvera/persona/users' do
      collection do
        post 'paged_index'
      end
    end
  end
end

app/helpers/media_objects_helper.rb
# Copyright 2011-2024, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
# 
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

module MediaObjectsHelper
  # Quick and dirty solution to the problem of displaying the right template.
  # Quick and dirty also gets it done faster.
  def current_step_for(status=nil)
    if status.nil?
      status = HYDRANT_STEPS.first
    end

    HYDRANT_STEPS.template(status)
  end

  # Based on the current context it will choose which class should be
  # applied to the display. If you are not using Twitter Bootstrap or
  # want different defaults then change them here.
  #
  # The context here is the media_object you are working with.
  def class_for_step(context, step)
    css_class = case
      # when context.workflow.current?(step)
      #   'nav-info'
      when context.workflow.completed?(step)
        'nav-success'
      else 'nav-disabled'
      end

    css_class
 end

  def form_id_for_step(step)
    "#{step.gsub('-','_')}_form"
  end

  def dropbox_url collection
     ic = Iconv.new('UTF-8//IGNORE', 'UTF-8')
     path = Addressable::URI.escape_component(collection.dropbox_directory_name || "", %r{[/\\%& #]})
     url = File.join(Settings.dropbox.upload_uri, path)
     ic.iconv(url)
  end

  def combined_display_date media_object
    (issued,created) = case media_object
    when MediaObject, SpeedyAF::Proxy::MediaObject
      [media_object.date_issued, media_object.date_created]
    when Hash
      [media_object[:document]['date_issued_ssi'], media_object[:document]['date_created_ssi']]
    end
    result = issued
    result += " (Creation date: #{created})" if created.present?
    result
  end

  def display_other_identifiers media_object
    # bibliographic_id has form [:type,"value"], other_identifier has form [[:type,"value],[:type,"value"],...]
    ids = media_object.bibliographic_id.present? ? [media_object.bibliographic_id] : []
    ids += Array(media_object.other_identifier)
    ids.uniq.collect{|i| "#{ ModsDocument::IDENTIFIER_TYPES[i[:source]] }: #{ i[:id] }" }
  end

  def display_notes media_object
    note_string = ""
    note_types = ModsDocument::NOTE_TYPES.clone
    note_types['table of contents']='Contents'
    sorted_note_types = note_types.keys.sort
    sorted_note_types.prepend(sorted_note_types.delete 'general')
    sorted_note_types.each do |note_type|
      notes = note_type == 'table of contents'? media_object.table_of_contents : gather_notes_of_type(media_object, note_type)
      notes.each_with_index do |note, i|
        note_string += "<p class='item_note_header'>#{note_types[note_type]}</p>" if i==0 and note_type!='general'
        note_string += "<pre>#{note}</pre>"
      end
    end
    note_string
  end

  def gather_notes_of_type media_object, type
    media_object.note.present? ? media_object.note.select{|n| n[:type]==type}.collect{|n|n[:note]} : []
  end

  def display_collection(media_object)
    link_to(media_object.collection.name, collection_path(media_object.collection.id))
  end

  def display_unit(media_object)
    link_to(media_object.collection.unit, collections_path(filter: media_object.collection.unit))
  end

  def display_language media_object
    media_object.language.collect{|l|l[:text]}.uniq
  end

  def display_related_item media_object
    media_object.related_item_url.collect{ |r| link_to( r[:label], r[:url]) }
  end

  def display_series media_object
    media_object.series.collect { |s| link_to(s, blacklight_path({ "f[collection_ssim][]" => media_object.collection.name, "f[series_ssim][]" => s }))}
  end

  def display_rights_statement media_object
    return nil unless media_object.rights_statement.present?
    label = ModsDocument::RIGHTS_STATEMENTS[media_object.rights_statement]
    return nil unless label.present?
    link = link_to label, media_object.rights_statement, target: '_blank'
    content_tag(:dt, 'Rights Statement') + content_tag(:dd) { link }
  end

  def current_quality stream_info
    available_qualities = Array(stream_info[:stream_flash]).collect {|s| s[:quality]}
    available_qualities += Array(stream_info[:stream_hls]).collect {|s| s[:quality]}
    available_qualities.uniq!
    quality ||= session[:quality] if session['quality'].present? && available_qualities.include?(session[:quality])
    quality ||= Settings.streaming.default_quality if available_qualities.include?(Settings.streaming.default_quality)
    quality ||= available_qualities.first
    quality
  end

  def is_current_section? section
     @currentStream && ( section.id == @currentStream.id )
  end

  def show_progress?(sections)
    encode_gids = sections.collect { |mf| "gid://ActiveEncode/#{mf.encoder_class}/#{mf.workflow_id}" }
    ActiveEncode::EncodeRecord.where(global_id: encode_gids).any? { |encode| encode.state.to_s.upcase != 'COMPLETED' }
  end

  def any_failed?(sections)
    encode_gids = sections.collect { |mf| "gid://ActiveEncode/#{mf.encoder_class}/#{mf.workflow_id}" }
    ActiveEncode::EncodeRecord.where(global_id: encode_gids).any? { |encode| encode.state.to_s.upcase == 'FAILED' }
  end

  def parse_section section, node, index
    sectionnode = section.structuralMetadata.xpath('//Item')
    if sectionnode.children.present?
      tracknumber = 0
      contents = ''
      sectionnode.children.each do |node|
        next if node.blank?
        st, tracknumber = parse_node section, node, tracknumber
        contents+=st
      end
    else
      contents, tracknumber = parse_node section, sectionnode.first, index
    end
    return contents, tracknumber
  end

  def parse_node section, node, tracknumber
    if node.name.upcase=="DIV"
      contents = ''
      node.children.each do |n|
        next if n.blank?
        nodecontent, tracknumber = parse_node section, n, tracknumber
        contents+=nodecontent
      end
      return "<li>#{node.attribute('label')}</li><li><ul>#{contents}</ul></li>", tracknumber
    elsif ['SPAN','ITEM'].include? node.name.upcase
      tracknumber += 1
      start, stop = get_xml_media_fragment node, section
      label = "#{tracknumber}. #{node.attribute('label').value} (#{get_duration_from_fragment(start, stop)})"
      native_url = "#{id_section_media_object_path(@media_object, section.id)}?t=#{start},#{stop}"
      url = "#{share_link_for( section )}?t=#{start},#{stop}"
      segment_id = "#{section.id}-#{tracknumber}"
      data = {segment: section.id, is_video: section.file_format != 'Sound', native_url: native_url, fragmentbegin: start, fragmentend: stop}
      link = link_to label.html_safe, url, id: segment_id, data: data, class: 'playable structure wrap'
      return "<li class='stream-li'>#{link}</li>", tracknumber
    end
  end

  def get_xml_media_fragment node, section
    start = node.attribute('begin').present? ? node.attribute('begin').value : 0
    stop = node.attribute('end').present? ? node.attribute('end').value : section.duration.blank? ? 0 : milliseconds_to_formatted_time(section.duration.to_i)
    parse_media_fragment "#{start},#{stop}"
  end

  def get_duration node, section
    start,stop = get_xml_media_fragment node, section
    milliseconds_to_formatted_time((stop.to_i - start.to_i) * 1000, false)
  end

  def get_duration_from_fragment(start, stop)
    milliseconds_to_formatted_time((stop.to_i - start.to_i) * 1000, false)
  end

  # This method mirrors the one in the MediaObject model but makes use of the sections passed in which can be SpeedyAF Objects
  # This would be good to refactor in the future but speeds things up considerably for now
  def gather_all_comments(media_object, sections)
    media_object.comment.sort + sections.collect do |mf|
      mf.comment.reject(&:blank?).collect do |c|
        mf.display_title.present? ? "[#{mf.display_title}] #{c}" : c
      end.sort
    end.flatten.uniq
  end

  def display_supplemental_file_language(language)
    return LanguageTerm.find(language).text if language.present?
    Settings.caption_default.name
  end
end

app/views/media_objects/_administrative_links.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% if can? :update, @media_object %>
  <div id="administrative_options" class="d-inline-block">
    <%= link_to 'Edit', edit_media_object_path(@media_object), class: 'btn btn-primary text-nowrap' %>

    <% if @media_object.published? %>
    <% if can?(:unpublish, @media_object) %>
    <%= link_to 'Unpublish', update_status_media_object_path(@media_object, status:'unpublish'), method: :put, class: 'btn btn-primary' %>
    <% end %>
    <% else %>
    <%= link_to 'Publish', update_status_media_object_path(@media_object, status:'publish'), method: :put, class: 'btn btn-primary' %>
    <% end %>

    <% if Settings.intercom.present? and can? :intercom_push, @media_object %>
    <%= button_tag(Settings.intercom['default']['push_label'], class: 'btn btn-outline text-nowrap', data: {toggle:"modal", target:"#intercom_push"}) %>
    <%= render "intercom_push_modal" %>
    <% end %>
  </div>
<% end %>

app/views/media_objects/_multipart_dropdown_field.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% selected_value ||= options[:dropdown_options].keys.first %>
<% fieldarray = options[:multivalued]? "[]" : "" %>

<div class="input-group-prepend">
  <% fieldname = "media_object[#{options[:dropdown_field]}]#{fieldarray}" %>
  <% option_hash = (options[:dropdown_options].values).zip(options[:dropdown_options].keys) %>
  <%= select_tag fieldname.to_s, options_for_select(option_hash, selected_value) %>
</div>

app/views/media_objects/_structure.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<p class="text-muted">Drag files to reorder them.</p>

<% if @masterFiles.blank? %>
  <div class="well">There are no media files</div>
<% else %>
  <div id="mediaobject_structure">
    <ul class="header">
      <li>Type</li>
      <li>Section label</li>
      <li>File name</li>
      <li>Size</li>
      <li></li>
    </ul>
    <ul class="sortable">
      <% @masterFiles.each_with_index do |section, index| %>
      <li class="section" data-segment="<%= section.id %>">
        <ul class="fileinfo">
          <li>
            <% case section.file_format
                when 'Sound' %>
            <i class="fa fa-volume-up"></i>
            <% when 'Moving image' %>
            <i class="fa fa-film"></i>
            <% else %>
            <i class="fa fa-question-sign"></i>
            <% end %>
          </li>
          <li>
            <%= section.title.blank? ? '&#8212;'.html_safe : section.title %>
          </li>
          <li class="mediaobject-filename">
            <% if section.file_location.present? %>
            <%= truncate_center(File.basename(section.file_location.to_s), 50, 20) %>
            <% else %>
            -
            <% end %>
          </li>
          <li>
            <%= number_to_human_size(section.file_size) %>
          </li>
          <li>
            <button class="btn btn-outline btn-struct" type="button" data-toggle="collapse" data-target="#structure_<%= index %>" aria-expanded="false" aria-controls="structure_<%= index %>">
              Edit Structure
            </button>
          </li>
        </ul>
        <div id="structure_<%= index %>" class="collapse structure_tool">
          <div class="tool_actions">
            <span class="tool_label">Structure</span>
            <%= form_for section, :url => attach_structure_master_file_path(section.id), html: {method: "post"} do |form| %>
            <%= form.file_field :structure, id: "structure_#{index}_filedata", class: "filedata", style: "display:none;" %>
            <% item_label=html_escape(stream_label_for(section)) %>
            <% stream_url=hls_manifest_master_file_url(section.id, quality: 'auto') %>
            <div class="btn-toolbar">
              <label class="btn btn-primary btn-struct mr-1 file-upload-label" for="structure_<%= index %>_filedata"><%= section.structuralMetadata.present? ? 'Replace' : 'Upload'%></label>
              <% if section.structuralMetadata.valid? %>
                <%= react_component("ReactButtonContainer", {canvasIndex: index, mediaObjectID: @media_object.id, masterFileID: section.id, baseURL: request.protocol+request.host_with_port, initStructure: section.structuralMetadata.as_json}, html_options={ class: 'react-button-container' }) %>
              <% else %>
                <%= react_component("ReactButtonContainer", {canvasIndex: index, mediaObjectID: @media_object.id, masterFileID: section.id, baseURL: request.protocol+request.host_with_port, initStructure: { label: "#{item_label}", type: "div", items: [] }}, html_options={ class: 'react-button-container' }) %>
              <% end %>
              <button type="button" class="btn btn-primary btn-struct mr-1" value="Advanced Edit" data-toggle="modal"
                data-target="#advanced_edit_structure_<%= index %>">Advanced Edit</button>
              <% if section.structuralMetadata.present? %>
                <%= link_to 'Remove', structure_master_file_path(section.id), method: :delete, class: 'btn btn-danger btn-struct btn-confirmation', data: {placement: 'top'} %>
              <% end %>
            </div>
            <% end %>
          </div>
          <div class="structure_view"></div>
          <div style="margin-top: 5px; font-style: italic;">
            Note: Any edits made with the Edit Structure tool will not be reflected here or in the Advanced Edit tool
            until this page is refreshed.
          </div>
        </div>
      </li>
      <% end %>
    </ul>
  </div>
  <br class="clear" />
  <%= bootstrap_form_for @media_object do |media| %>
  <%= render "workflow_buttons" %>
<% end %>

<% @masterFiles.each_with_index do |section, index| %>
<% default_structure="<Item label='#{html_escape(stream_label_for(section))}'></Item>" %>
<div id="advanced_edit_structure_<%= index %>" class="structure_edit modal fade" data-backdrop="static"
  data-submit_url="<%= attach_structure_master_file_path(section.id) %>">
  <div class="modal-dialog modal-xl" style="width:65%">
    <div class="modal-content col-md-12">
      <div class="modal-header">
        <h4 class="modal-title">Advanced Edit Structure</h4>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
      </div>
      <div class="modal-body structure_edit col-md-12" style="height:40vh">
        <textarea rows=20 class="col-md-12 original_textarea" id="structure_<%= index %>"
          style="visibility:hidden"><%= section.structuralMetadata.valid? ? section.structuralMetadata.to_xml : default_structure %></textarea>
      </div>
    </div>
  </div>
</div>
<% end %>
<% end %>

<% content_for :page_scripts do %>
<script>
  function htmlDecode(value) {
    return $('<div/>').html(value).text();
  }

  function parse_structure(xml, index) {
    var $xml = $($.parseXML(xml));
    var $item = $xml.find("Item");
    if ($item.length) {
      if ($item.children().length) return "<span>" + $item.attr('label') + "</span><ul>" + parse_section($item.first(),
        index)[0] + "</ul>";
      else return "<span>" + (index + 1) + ". " + $item.attr('label') + "</span>";
    } else return "";
  }

  function parse_section(node, index) {
    var contents = '';
    var tracknumber;
    var nodecontents;
    if (node.children().length) {
      tracknumber = 0;
      $.each(node.children(), function (index, node) {
        nodecontents = parse_node(node, tracknumber);
        contents += nodecontents[0];
        tracknumber = nodecontents[1];
      });
    } else {
      nodecontents = parse_node(node.first, index);
      contents = nodecontents[0];
      tracknumber = nodecontents[1];
    }
    return [contents, tracknumber];
  }

  function parse_node(node, tracknumber) {
    if (node.nodeName.toUpperCase() == "DIV") {
      var contents = ''
      $.each($(node).children(), function (index, node) {
        var nodecontents = parse_node(node, tracknumber);
        contents += nodecontents[0];
        tracknumber = nodecontents[1];
      });
      return ["<li>" + $(node).attr('label') + "</li><li><ul>" + contents + "</ul></li>", tracknumber];
    } else if ($.inArray(node.nodeName.toUpperCase(), ['SPAN', 'ITEM']) != -1) {
      tracknumber += 1;
      return ["<li class='stream-li'>" + tracknumber + ". " + $(node).attr('label') + "</li>", tracknumber];
    } else {
      return ["", tracknumber];
    }
  }

  $('.filedata').change(function () {
    $(this).closest('form').submit();
  });

  function populate_structure_preview(index) {
    $xmltextarea = $('#advanced_edit_structure_' + index).find('textarea.original_textarea');
    $('#structure_' + index).find('.structure_view').html(parse_structure(htmlDecode($xmltextarea.html()), index));
  }

  function attach_structure_response(r) {
    if (r['flash'] && r['flash'].length) {
      msg = ''
      for (var i = 0; i < r['flash'].length; i++) {
        for (var j = 0; j < r['flash'][i][1].length; j++) {
          msg += r['flash'][i][1][j] + '<br/>';
        }
      }
      return msg;
    } else {
      modal = $(`.structure_edit[data-submit_url='${$(this)[0].url}']`)
      modal.find('textarea.original_textarea').html(r['structure']);
      section_index = parseInt(modal.attr('id').split('_').pop());
      populate_structure_preview(section_index);
      modal.modal('hide');
    }
  }

  var extractor = new Xsd2Json('avalon_structure.xsd', {
    'schemaURI': '/',
    'rootElement': 'item'
  });
  $('.structure_edit.modal').on('shown.bs.modal', function () {
    modal = $(this);
    if (modal.find('.xml_editor_container').length > 0) return;

    te = modal.find('.original_textarea').first();
    te.xmlEditor({
      schema: extractor.getSchema(),
      floatingMenu: false,
      confirmExitWhenUnsubmitted: false,
      loadSchemaAsychronously: false,
      xmlEditorLabel: 'Graphical',
      textEditorLabel: 'Raw XML',
      containerElement: {
        element: modal.find('.modal-body').first(),
        fixedHeight: true,
      },
      submitButtonConfigs: [{
        url: $(this).data('submit_url'),
        responseHandler: attach_structure_response,
        label: 'Save and Exit',
        cssClass: 'btn btn-primary section_edit_submit',
      }],
      defaultView: 'text',
    });
  });
</script>
<% end %>